require "turretbase"
require "util"
require "upgradestats"

local curTurrets = {}

function GenerateTurrets()
	-- Start with the base turret.
	table.insert(curTurrets, turretbase)
	
	for i, upgrade in pairs(upgrades) do
		GenUpgrade(upgrade)
	end
	
	return curTurrets
end

function GenUpgrade(upgrade)
	local newTurrets = {}
	for i, turret in pairs(curTurrets) do
		-- Append the upgrade name. ("gun-turret-range", "gun-turret-range3-armor")
		turret.name = turret.name .. "-" .. upgrade.upgradeName
		for level, value in ipairs(upgrade.values) do
			local newTurret = table.deepcopy(turret)
			
			newTurret.order = "a-a-a"
			
			newTurret.name = turret.name .. level
			newTurret[upgrade.valueName] = value
			table.insert(newTurrets, newTurret)
		end
	end
	
	curTurrets = newTurrets
end

data:extend(
	GenerateTurrets()
)
