require "upgradestats"

-- Needed to generate order string.
local alphabet = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"}

function GenerateResearch()
	local researchtypes = {}
	local researches = {}
	
	for i, tbl in ipairs(technologies) do
	
		-- Generate prerequisites automatically.
		if not researchtypes[tbl[1]] then
			researchtypes[tbl[1]] = 1
		else
			researchtypes[tbl[1]] = researchtypes[tbl[1]] + 1
		end
		
		local num = researchtypes[tbl[1]]
		local prereqs = {}
		
		if num > 1 then
			prereqs = {entityBaseName .. "-" .. tbl[1] .. (num - 1)}
		else
			prereqs = baseTechRequirements
		end
		
		
		-- Generate the research itself.
		local research = {
			type = "technology",
			name = entityBaseName .. "-" .. tbl[1] .. num,
			icon = "__base__/graphics/technology/gun-turret-damage.png",
			prerequisites = prereqs,
			unit =
			{
				count = tbl[2],
				ingredients =
				{
					{"science-pack-1", tbl[4]}
				},
				time = tbl[3]
			},
			upgrade = "true",
			-- Gun turret technologies end at f.
			order = "e-p-a-" .. alphabet[i],
		}
		
		-- Insert science pack costs if necessary.
		if tbl[5] then
			table.insert(research.unit.ingredients, {"science-pack-2", tbl[5]})
		end
		if tbl[6] then
			table.insert(research.unit.ingredients, {"science-pack-3", tbl[6]})
		end
		if tbl[7] then
			table.insert(research.unit.ingredients, {"alien-science-pack", tbl[7]})
		end
		
		table.insert(researches, research)
	end
	
	return researches
end

				
data:extend(
	GenerateResearch()
)
